;--------------------------------------------------------------------
;: RPG_Daggerfall v0.01 - 03.08.2024
;:  Dragons' Lord '2021-2024
;--------------------------------------------------------------------

;dalnost=%11111111  ;%11111100 1024 .. %11111110 512 .. %11111111 256

CHECKZONEXY_DOOBJ_SMALL=!HIMEM;1 ;0 -     , 1 -    

OBJSIZE=6+1;+2
OBJSIZE_skipafteralpha=1;+2

SEGM=16  +1 ;75 -       

       macro DWOBJ x_,y_,z_,alpha
        dw -(x_),-(y_),z_
        db alpha
       endm
       
       macro DWOB x_,y_
        dw -(x_),-(y_)
       endm

       ;,      256.      ,    .      .
        macro CHECKZONEXY obj,skipaddr ;-256..+256 (     192   )
        ld hl,(obj)
        add hl,de       ;objX-camX
        srl h
        jr nz,skipaddr
        ld hl,(obj+2)
        add hl,bc       ;objY-camY
        srl h
        jr nz,skipaddr
        endm

       ;   .       -   
        macro CHECKZONEXY_FAR obj,skipaddr ;-512..+512 (      192   !)
        ld hl,(obj)
        add hl,de       ;objX-camX
        ld a,h
        inc a
        cp 4
        jp nc,skipaddr
        ld hl,(obj+2)
        add hl,bc       ;objY-camY
        ld a,h
        inc a
        cp 4
        jr nc,skipaddr
        endm

        macro ENDZONE_SETREGS
        call zone_setregs
        endm
        

my_objects
        call controllerMap
        
        ld hl,(mcamx)
        ld (camX),hl  
         or a
         ld de,-8*64
         sbc hl,de
         ld a,l
         and %11000000
         ld l,a
         ld (deltaX),hl
        ld hl,(mcamy)
        ld (camY),hl
         or a
         ld de,-8*64
         sbc hl,de
         ld a,l
         and %11000000
         ld l,a
         ld (deltaY),hl

        ld      a,(sysDalnost)
        or a ;cp      0
        jr      nz,sysDalnost1
sysDalnost0        
camX=$+1
        ld de,0;(camX)             ;X   
camY=$+1
        ld hl,0;(camY)             ;Y   
        jr sysDalnostExit
        
sysDalnost1
;    -32..+32    ..
;      64 ( sin  cos  -96..+96 (-192..+192))
;     192   
DISTCOSLIMIT=96;112    
        ld hl,(frame_azimuth)   ;    50175 c3ff 11000011 11111111
                                ;                                    49920 c300 11000011 00000000
        ld h,tcos_himem/256;tcos/256;tcosmy/256         ;tsindiv2 tcos tsinmy tcosmy
        ld a,(hl)               ;cos -128..+127
        cp 128-DISTCOSLIMIT;32
        jp po,$+3+2 ;pe=overflow
         ld a,-DISTCOSLIMIT;-96
        add a,128-DISTCOSLIMIT;32
        ld a,(hl)
        jp po,$+3+2 ;pe=overflow
         ld a,+DISTCOSLIMIT;+96
        add a,a
        ld e,a
       sbc a,a
       ld d,a                   ;cosx2 = -1..+1
        ld a,64
        sub l
        ld l,a
        ;ld h,tcos/256;tsinmy/256         ;tsindiv2 tcos tsinmy tcosmy
        ld a,(hl)               ;cos -128..+127
        cp 128-DISTCOSLIMIT;32
        jp po,$+3+2 ;pe=overflow
         ld a,-DISTCOSLIMIT;-96
        add a,128-DISTCOSLIMIT;32
        ld a,(hl)
        jp po,$+3+2 ;pe=overflow
         ld a,+DISTCOSLIMIT;+96
        add a,a
        ld c,a
       sbc a,a
       ld b,a                   ;sinx2 = -1..+1    

        ld hl,(camX)            ;  X
        or a
        sbc hl,de               ; cos
        ex de,hl
        ld hl,(camY)            ;  Y
        or a
        sbc hl,bc               ; sin       

sysDalnostExit
;de=centerX
;hl=centerY
        ld (centerY),hl
        ld (centerX),de
       ld bc,256-33;32 ;256=  
       add hl,bc
        ld (centerYbase),hl
        ex de,hl
       add hl,bc ;256=  
        ld (centerXbase),hl

      if !ATM
       if SHOWXYZON
        call viewxyz ;9000  -  XXXXX_YYYYY_ZZZZZ
       endif
      endif

       ;  
       ;X
        ld de,(centerX)
        or a
        ld hl,-128-32 ;-32   
        sbc hl,de
        ld a,l
        and %11000000
        ld l,a
       ld (obj000X),hl

       ;Y
setYkubits
        ld de,(centerY)
        or a
        ld hl,-128-32 ;-32   
        sbc hl,de        
        ld a,l
        and %11000000
        ld l,a
       ld (obj000Y),hl

        ; z  = z ,   
setZkubits
        ld hl,8*64
        ld de,8*64
        call visiblSegmCP
        ;cp      SEGM
         ;ld hl,m+8*16+8
         ;ld a,(hl)
         ;cp SEGM        
        jp nc,models            ; >=SEGM  ret
        ;     Z    ,   
        ld hl,tabZ
        ld b,0
        ld c,a
        add hl,bc         
        ld c,(hl)               ; Z  
        ld hl,ROST              ;
        add hl,bc
        ld (mcamz_min),hl       ;   Z  


models
;**********************************************************************************
;*****     *********************************
;**********************************************************************************
obj000X=$+1
        ld bc,0 ;-> bc
        ld l,8
qbits0
obj000Y=$+1
        ld de,0 ;-> de
        ld h,8
qbits1
        push bc
        push de
        push hl
;de=Y*64
;bc=X*64        
deltaX=$+1
         ld hl,0 ;    X   X=-8
         add hl,bc        
        add hl,hl       ;  X
        add hl,hl       ;  
        ld a,h          ;X
       push de
deltaY=$+1
         ld hl,0 ;    Y   Y=-8
         add hl,de         
        srl h : rr l : srl h : rr l ;hl=Y*64->Y*16
        ld de,m
        add hl,de        
        ld d,0 : ld e,a
        add hl,de       ;m+Y*16+X
       pop de

        ld a,(hl)         
        or a
        jr z,no_setobj

;_setobj
;      ,  Alpha  
;:
;a =  ,    
;bc=-X
;de=-Y
        ld (qbitsZ),a     ;   Z 
        ld hl,tabObj       ;    
       add a,a
       add a,l
       ld l,a
       jr nc,$+3
       inc h
        ld a,(hl)
        ld lx,a
        inc hl
        ld a,(hl)
       bit 7,a
       set 7,a ;addr >= 0x8000
        ld hx,a
        ld a,(ix-1) ;alpha ;     ,     vertex (lowmem)!!!
       jr z,_setobj_alpha
       xor a
_setobj_alpha
        ex af,af' ;'
;-----------------------------------        
        ;ld hl,-32
        push bc
qbitsZ=$+1        
        ld c,0
        ld b,0
        ld hl,tabZ
        add hl,bc         
        ld c,(hl)               ;   Z  
        xor a
        ld hl,-ROST+20 ;+10  -    ,    
        sub hl,bc
        pop bc   
;-----------------------------------
;bc=-X
;de=-Y
;hl=Z
;a'=alpha
        call DOOBJ
no_setobj
        pop hl
        pop de
        ld a,e
        add a,64
        ld e,a
        jr nc,$+3
        inc d
        pop bc
        dec h
        jr nz,qbits1
        ld a,c
        add a,64
        ld c,a
        jr nc,$+3
        inc b
        dec l
        jr nz,qbits0

        call zone_setregs






       if 0 
        CHECKZONEXY obj000,zone000exit
;-------------------------------------------------------------------
; obj000 -  
;-------------------------------------------------------------------
        ld hl,obj000
        call getobjXYZ
        ;call shaderUpDn
        call shaderRotatRT
	ld ix,t06 ;2,4,5,6
        call DOOBJ_JR
obj000  DWOBJ -21*64,-11*64,-48,0
        ENDZONE_SETREGS
zone000exit
       endif 






        if 0
;==========================================================================
;   
        CHECKZONEXY obj102,zone102exit
;-------------------------------------------------------------------
; obj102 -  1/5 
;-------------------------------------------------------------------
;ix102	ld ix,kzvd
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj102  DWOBJ -31*64,-27*64,33 ,0
;-------------------------------------------------------------------
        ;ENDZONE_SETREGS
zone102exit

        CHECKZONEXY obj156,zone156exit
;-------------------------------------------------------------------
; obj156 -  1/5 
;-------------------------------------------------------------------
;ix156	ld ix,kzvd
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj156  DWOBJ -32*64+9,-27*64+4,33 ,-51
;-------------------------------------------------------------------
        ;ENDZONE_SETREGS
zone156exit

        CHECKZONEXY obj157,zone157exit
;-------------------------------------------------------------------
; obj157 -  1/5 
;-------------------------------------------------------------------
;ix157	ld ix,kzvd
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj157  DWOBJ -32*64-13,-28*64+18,33 ,-102
;-------------------------------------------------------------------
        ;ENDZONE_SETREGS
zone157exit

        CHECKZONEXY obj158,zone158exit
;-------------------------------------------------------------------
; obj158 -  1/5 
;-------------------------------------------------------------------
;ix158	ld ix,kzvd
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj158  DWOBJ -31*64+12,-28*64+10,33 ,51
;-------------------------------------------------------------------
        ;ENDZONE_SETREGS
zone158exit

        CHECKZONEXY obj159,zone159exit
;-------------------------------------------------------------------
; obj159 -  1/5 
;-------------------------------------------------------------------
;ix159	ld ix,kzvd
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj159  DWOBJ -31*64-34,-28*64-18,33 ,102
;-------------------------------------------------------------------
        ;ENDZONE_SETREGS
zone159exit

;    
        CHECKZONEXY obj206,zone206exit
;-------------------------------------------------------------------
; obj206 -  1/5 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj206  DWOBJ (-31+11)*64,(-27-28)*64-40,33 ,0
zone206exit

        CHECKZONEXY obj207,zone207exit
;-------------------------------------------------------------------
; obj207 -  1/5 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj207  DWOBJ (-32+11)*64+9,(-27-28)*64+4-40,33 ,-51
zone207exit

        CHECKZONEXY obj208,zone208exit
;-------------------------------------------------------------------
; obj208 -  1/5 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj208  DWOBJ (-32+11)*64-13,(-28-28)*64+18-40,33 ,-102
zone208exit

        CHECKZONEXY obj209,zone209exit
;-------------------------------------------------------------------
; obj209 -  1/5 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj209  DWOBJ (-31+11)*64+12,(-28-28)*64+10-40,33 ,51
zone209exit

        CHECKZONEXY obj210,zone210exit
;-------------------------------------------------------------------
; obj210 -  1/5 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw kzvd
obj210  DWOBJ (-31+11)*64-34,(-28-28)*64-18-40,33 ,102
zone210exit



;    
        CHECKZONEXY obj097,zone097exit
;-------------------------------------------------------------------
; obj097 -    
;-------------------------------------------------------------------
;ix097	ld ix,kpod
        call IXDOOBJ_NOSHADER_JR
        dw kpod
obj097  DWOBJ -19*64-32,-41*64-32,33,0
;-------------------------------------------------------------------
        ;ENDZONE_SETREGS
zone097exit

;     
        CHECKZONEXY obj185,zone185exit
;-------------------------------------------------------------------
; obj185 -    
;-------------------------------------------------------------------
;ix185	ld ix,kpod
        call IXDOOBJ_NOSHADER_JR
        dw kpod
obj185  DWOBJ -15*64-32,-12*64-32,33,0
;-------------------------------------------------------------------
        ;ENDZONE_SETREGS
zone185exit

;  
        CHECKZONEXY obj192,zone192exit
;-------------------------------------------------------------------
; obj192 -   
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw runeDoor1
obj192  DWOBJ -19*64-34,-22*64-36,-32,0
zone192exit

        CHECKZONEXY obj193,zone193exit
;-------------------------------------------------------------------
; obj193 -   
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw runeDoor1
obj193  DWOBJ -22*64+34,-22*64-36,-32,192
zone193exit

;  
        CHECKZONEXY obj194,zone194exit
;-------------------------------------------------------------------
; obj194 -   
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw runeDoor2
obj194  DWOBJ -39*64+36,-14*64-34,-32,192
zone194exit

        CHECKZONEXY obj195,zone195exit
;-------------------------------------------------------------------
; obj195 -   
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw runeDoor2
obj195  DWOBJ -39*64+36,-17*64+34,-32,128
zone195exit

;  
        CHECKZONEXY obj196,zone196exit
;-------------------------------------------------------------------
; obj196 -   
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw runeDoor3
obj196  DWOBJ -44*64-34,-48*64+36,-32,64
zone196exit

        CHECKZONEXY obj197,zone197exit
;-------------------------------------------------------------------
; obj197 -   
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw runeDoor3
obj197  DWOBJ -47*64+34,-48*64+36,-32,128
zone197exit

;   
        CHECKZONEXY obj198,zone198exit
;-------------------------------------------------------------------
; obj198 -  
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw portalExit
obj198  DWOBJ -42*64-32,-51*64+16,-48,128
zone198exit

        CHECKZONEXY obj199,zone199exit
;-------------------------------------------------------------------
; obj199 -  
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw portalExit
obj199  DWOBJ -42*64-32,-52*64-16,-48,0
zone199exit

; 
        CHECKZONEXY obj200,zone200exit
;-------------------------------------------------------------------
; obj200 -   ( )
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw portalExitUP
obj200  DWOBJ -42*64-32,-51*64+16,-106,128
zone200exit

        CHECKZONEXY obj201,zone201exit
;-------------------------------------------------------------------
; obj201 -   ( )
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw portalExitUP
obj201  DWOBJ -42*64-32,-52*64-16,-106,0
zone201exit

       if 0
;    
        CHECKZONEXY obj202,zone202exit
;-------------------------------------------------------------------
; obj202 -   ( )
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw portalExitPOSTER
obj202  DWOBJ -42*64-32,-52*64-32,-48,0
zone202exit
       endif
       
;obj213 -  !
        endif


  
  
  
       if 0
;==========================================================================
;
        CHECKZONEXY obj300,zone300exit
;-------------------------------------------------------------------
; obj300 -   - 1  
;-------------------------------------------------------------------
        ld hl,obj300
        call getobjXYZ
        call shaderUpDn
        call shaderRotatRT
	ld ix,modelAmmo1
        call DOOBJ_JR
obj300  DWOBJ -7*64,-27*64-32,-40,0
        ENDZONE_SETREGS
zone300exit
        
;
        CHECKZONEXY obj301,zone301exit
;-------------------------------------------------------------------
; obj301 -   - 2 
;-------------------------------------------------------------------
        ld hl,obj301
        call getobjXYZ
        call shaderUpDn
        call shaderRotatRT
	ld ix,modelAmmo2
        call DOOBJ_JR
obj301  DWOBJ -33*64-32,-12*64-32,-40,0
        ENDZONE_SETREGS
zone301exit

;
        CHECKZONEXY obj302,zone302exit
;-------------------------------------------------------------------
; obj302 -   - 3 
;-------------------------------------------------------------------
        ld hl,obj302
        call getobjXYZ
        call shaderUpDn
        call shaderRotatRT
	ld ix,modelAmmo3
        call DOOBJ_JR
obj302  DWOBJ -51*64-32,-37*64-32,-40,0
        ENDZONE_SETREGS
zone302exit

; 1
        CHECKZONEXY obj303,zone303exit
;-------------------------------------------------------------------
; obj303 -  1
;-------------------------------------------------------------------
        ld hl,obj303
        call getobjXYZ
        call shaderUpDn
        call shaderRotatRT
;rune1Model=$+2      
	ld ix,(rune1Model);runeShadow;rune1  ;DD21XXXX
        call DOOBJ_JR
obj303  DWOBJ -19*64-32,-41*64-32,-32,0
        ENDZONE_SETREGS
zone303exit

; 2
        CHECKZONEXY obj304,zone304exit
;-------------------------------------------------------------------
; obj304 -  2
;-------------------------------------------------------------------
        ld hl,obj304
        call getobjXYZ
        call shaderUpDn
        call shaderRotatRT
;rune2Model=$+2
	ld ix,(rune2Model);runeShadow;rune2  ;DD21XXXX
        call DOOBJ_JR
obj304  DWOBJ -15*64-32,-12*64-32,-32,0
        ENDZONE_SETREGS
zone304exit

; 3
        CHECKZONEXY obj305,zone305exit
;-------------------------------------------------------------------
; obj305 -  3
;-------------------------------------------------------------------
        ld hl,obj305
        call getobjXYZ
        call shaderUpDn
        call shaderRotatRT
;rune3Model=$+2
	ld ix,(rune3Model);runeShadow;rune3  ;DD21XXXX 
        call DOOBJ_JR
obj305  DWOBJ -31*64-32,-27*64-32,-32,0
        ENDZONE_SETREGS
zone305exit

; 4
        CHECKZONEXY obj312,zone312exit
;-------------------------------------------------------------------
; obj312 -  4
;-------------------------------------------------------------------
        ld hl,obj312
        call getobjXYZ
        call shaderUpDn
        call shaderRotatRT
;rune4Model=$+2
	ld ix,(rune4Model);runeShadow;rune4  ;DD21XXXX 
        call DOOBJ_JR
obj312  DWOBJ (-31+11)*64-32,(-27-28)*64-32-40,-32,0
        ENDZONE_SETREGS
zone312exit

;   ""
        CHECKZONEXY obj306,zone306exit
;-------------------------------------------------------------------
; obj306 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw knopkaOFF
obj306  DWOBJ -15*64-32,-8*64+22,-32,64
zone306exit

;   
        CHECKZONEXY obj307,zone307exit
;-------------------------------------------------------------------
; obj307 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw knopkaOFF
obj307  DWOBJ -50*64,-42*64+22,-32,64
zone307exit

       if 0 
        CHECKZONEXY obj308,zone308exit
;-------------------------------------------------------------------
; obj308 -  E
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw knopkaOFF
obj308  DWOBJ -10*64,-27*64+29,-32,64
zone308exit

        CHECKZONEXY obj309,zone309exit
;-------------------------------------------------------------------
; obj309 -  W
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw knopkaOFF
obj309  DWOBJ -10*64,-25*64-29,-32,192
zone309exit

        CHECKZONEXY obj310,zone310exit
;-------------------------------------------------------------------
; obj310 -  N
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw knopkaOFF
obj310  DWOBJ -11*64+29,-26*64,-32,128
zone310exit

        CHECKZONEXY obj311,zone311exit
;-------------------------------------------------------------------
; obj311 -  S
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
        dw knopkaOFF
obj311  DWOBJ -9*64-29,-26*64,-32,0
zone311exit
       endif 
       
;obj313 -  !       
       

;  

        CHECKZONEXY obj203,zone203exit
;-------------------------------------------------------------------
; obj203 -   
;-------------------------------------------------------------------
        ld hl,obj203
        call getobjXYZ
        ;call shaderUpDn
        call shaderRotatRT
	ld ix,box2
        call DOOBJ_JR
obj203  DWOBJ -9*64-32,-12*64-32,-8,0
        ENDZONE_SETREGS
zone203exit

        CHECKZONEXY obj170,zone170exit
;-------------------------------------------------------------------
; obj170 -   
;-------------------------------------------------------------------
        ld hl,obj170
        call getobjXYZ
        ;call shaderUpDn
        call shaderRotatRT
	ld ix,box1
        call DOOBJ_JR
obj170  DWOBJ -22*64+32,-12*64-32,-8,0
        ENDZONE_SETREGS
zone170exit

        CHECKZONEXY obj171,zone171exit
;-------------------------------------------------------------------
; obj171 -   
;-------------------------------------------------------------------
        ld hl,obj171
        call getobjXYZ
        ;call shaderUpDn
        call shaderRotatRT
	ld ix,box2
        call DOOBJ_JR
obj171  DWOBJ -53*64-32,-27*64,-8,0
        ENDZONE_SETREGS
zone171exit

        CHECKZONEXY obj172,zone172exit
;-------------------------------------------------------------------
; obj172 -   
;-------------------------------------------------------------------
        ld hl,obj172
        call getobjXYZ
        ;call shaderUpDn
        call shaderRotatRT
	ld ix,box3
        call DOOBJ_JR
obj172  DWOBJ -26*64,-23*64,-8,0
        ENDZONE_SETREGS
zone172exit

       if HIMEM
        CHECKZONEXY obj204,zone204exit
;-------------------------------------------------------------------
; obj204 - 
;-------------------------------------------------------------------
        ld hl,obj204
        call getobjXYZ
        ;call shaderUpDn
        call shaderRotatRT
	ld ix,boxM
        call DOOBJ_JR
obj204  DWOBJ -55*64-32,-27*64,-8,0
        ENDZONE_SETREGS
zone204exit

        CHECKZONEXY obj205,zone205exit
;-------------------------------------------------------------------
; obj205 - 
;-------------------------------------------------------------------
        ld hl,obj205
        call getobjXYZ
        ;call shaderUpDn
        call shaderRotatRT
	ld ix,boxM
        call DOOBJ_JR
obj205  DWOBJ -26*64,-32*64,-8,0
        ENDZONE_SETREGS
zone205exit
       endif 
       
        CHECKZONEXY obj214,zone214exit
;-------------------------------------------------------------------
; obj214 -   
;-------------------------------------------------------------------
        ld hl,obj214
        call getobjXYZ
        ;call shaderUpDn
        call shaderRotatRT
	ld ix,box3
        call DOOBJ_JR
obj214  DWOBJ -21*64,-54*64,-8,0
        ENDZONE_SETREGS
zone214exit

        CHECKZONEXY obj215,zone215exit
;-------------------------------------------------------------------
; obj215 -   
;-------------------------------------------------------------------
        ld hl,obj215
        call getobjXYZ
        ;call shaderUpDn
        call shaderRotatRT
	ld ix,box3
        call DOOBJ_JR
obj215  DWOBJ -21*64,-58*64-32,-8,0
        ENDZONE_SETREGS
zone215exit       
       endif

       if 0
;==========================================================================
;==  ()
;==========================================================================

        CHECKZONEXY obj250,zone250exit
;-------------------------------------------------------------------
; obj250 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
bochka250obj      
        dw bochka
obj250  DWOBJ -11*64,-51*64,-16 ,0
zone250exit

        CHECKZONEXY obj251,zone251exit
;-------------------------------------------------------------------
; obj251 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
bochka251obj      
        dw bochka
obj251  DWOBJ -11*64,-61*64,-16 ,0
zone251exit

        CHECKZONEXY obj252,zone252exit
;-------------------------------------------------------------------
; obj252 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
bochka252obj      
        dw bochka
obj252  DWOBJ -12*64,-55*64,-16 ,0
zone252exit

        CHECKZONEXY obj253,zone253exit
;-------------------------------------------------------------------
; obj253 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
bochka253obj      
        dw bochka
obj253  DWOBJ -14*64,-57*64,-16 ,0
zone253exit
       endif


      
;==========================================================================
;== 
;==========================================================================

        CHECKZONEXY obj400,zone400exit
;-------------------------------------------------------------------
; obj400 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shot400obj        
        dw modelShot1
obj400  DWOBJ 0,0,-500,0
zone400exit

        CHECKZONEXY obj401,zone401exit
;-------------------------------------------------------------------
; obj401 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shot401obj        
        dw modelShot1
obj401  DWOBJ 0,0,-500,0
zone401exit

        CHECKZONEXY obj402,zone402exit
;-------------------------------------------------------------------
; obj402 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shot402obj        
        dw modelShot1
obj402  DWOBJ 0,0,-500,0
zone402exit

        CHECKZONEXY obj403,zone403exit
;-------------------------------------------------------------------
; obj403 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shot403obj
        dw modelShot1
obj403  DWOBJ 0,0,-500,0
zone403exit

        CHECKZONEXY obj404,zone404exit
;-------------------------------------------------------------------
; obj404 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shot404obj        
        dw modelShot1
obj404  DWOBJ 0,0,-500,0
zone404exit

        CHECKZONEXY obj405,zone405exit
;-------------------------------------------------------------------
; obj405 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shot405obj        
        dw modelShot1
obj405  DWOBJ 0,0,-500,0
zone405exit

        CHECKZONEXY obj406,zone406exit
;-------------------------------------------------------------------
; obj406 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shot406obj        
        dw modelShot1
obj406  DWOBJ 0,0,-500,0
zone406exit

        CHECKZONEXY obj407,zone407exit
;-------------------------------------------------------------------
; obj407 - 
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shot407obj        
        dw modelShot1
obj407  DWOBJ 0,0,-500,0
zone407exit






;==========================================================================
;== TURBO 
;==========================================================================

        CHECKZONEXY obj601,zone601exit
;-------------------------------------------------------------------
; obj601 - turboSvine
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
turboSvine601obj
        dw turboSvine0
obj601  DWOBJ 0,0,-512,0
zone601exit

        CHECKZONEXY obj602,zone602exit
;-------------------------------------------------------------------
; obj602 - turboSvine
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
turboSvine602obj
        dw turboSvine0
obj602  DWOBJ 0,0,-512,0
zone602exit

        CHECKZONEXY obj603,zone603exit
;-------------------------------------------------------------------
; obj603 - turboSvine
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
turboSvine603obj
        dw turboSvine0
obj603  DWOBJ 0,0,-512,0
zone603exit

        CHECKZONEXY obj604,zone604exit
;-------------------------------------------------------------------
; obj604 - turboSvine
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
turboSvine604obj
        dw turboSvine0
obj604  DWOBJ 0,0,-512,0
zone604exit

        CHECKZONEXY obj605,zone605exit
;-------------------------------------------------------------------
; obj605 - turboSvine
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
turboSvine605obj
        dw turboSvine0
obj605  DWOBJ 0,0,-512,0
zone605exit

        CHECKZONEXY obj606,zone606exit
;-------------------------------------------------------------------
; obj606 - turboSvine
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
turboSvine606obj
        dw turboSvine0
obj606  DWOBJ 0,0,-512,0
zone606exit

;==========================================================================
;==  ()
;==========================================================================

        CHECKZONEXY obj611,zone611exit
;-------------------------------------------------------------------
; obj611 - Vorchun
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
vorchun611obj
        dw vorchun
obj611  DWOBJ 0,0,-512,0
zone611exit   

        CHECKZONEXY obj612,zone612exit
;-------------------------------------------------------------------
; obj612 - Vorchun
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
vorchun612obj
        dw vorchun
obj612  DWOBJ 0,0,-512,0
zone612exit

        CHECKZONEXY obj613,zone613exit
;-------------------------------------------------------------------
; obj613 - Vorchun
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
vorchun613obj
        dw vorchun
obj613  DWOBJ 0,0,-512,0
zone613exit

;==========================================================================
;== 
;==========================================================================

        CHECKZONEXY obj621,zone621exit
;-------------------------------------------------------------------
; obj621 - Shambler
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shambler621obj
        dw shambler01
obj621  DWOBJ 0,0,-512,0
zone621exit   

        CHECKZONEXY obj622,zone622exit
;-------------------------------------------------------------------
; obj622 - Shambler
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shambler622obj
        dw shambler01
obj622  DWOBJ 0,0,-512,0
zone622exit 









;==========================================================================
;== 
;==========================================================================

        CHECKZONEXY obj500,zone500exit
;-------------------------------------------------------------------
; obj500 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode500obj
        dw modelExplode1
obj500  DWOBJ 0,0,-500,0
zone500exit

        CHECKZONEXY obj501,zone501exit
;-------------------------------------------------------------------
; obj501 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode501obj
        dw modelExplode1
obj501  DWOBJ 0,0,-500,0
zone501exit

        CHECKZONEXY obj502,zone502exit
;-------------------------------------------------------------------
; obj502 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode502obj
        dw modelExplode1
obj502  DWOBJ 0,0,-500,0
zone502exit


       if HIMEM

        CHECKZONEXY obj503,zone503exit
;-------------------------------------------------------------------
; obj503 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode503obj
        dw modelExplode1
obj503  DWOBJ 0,0,-500,0
zone503exit

        CHECKZONEXY obj504,zone504exit
;-------------------------------------------------------------------
; obj504 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode504obj
        dw modelExplode1
obj504  DWOBJ 0,0,-500,0
zone504exit

        CHECKZONEXY obj505,zone505exit
;-------------------------------------------------------------------
; obj505 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode505obj
        dw modelExplode1
obj505  DWOBJ 0,0,-500,0
zone505exit

        CHECKZONEXY obj506,zone506exit
;-------------------------------------------------------------------
; obj506 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode506obj
        dw modelExplode1
obj506  DWOBJ 0,0,-500,0
zone506exit

        CHECKZONEXY obj507,zone507exit
;-------------------------------------------------------------------
; obj507 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode507obj
        dw modelExplode1
obj507  DWOBJ 0,0,-500,0
zone507exit

        CHECKZONEXY obj508,zone508exit
;-------------------------------------------------------------------
; obj508 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode508obj
        dw modelExplode1
obj508  DWOBJ 0,0,-500,0
zone508exit

        CHECKZONEXY obj509,zone509exit
;-------------------------------------------------------------------
; obj509 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode509obj
        dw modelExplode1
obj509  DWOBJ 0,0,-500,0
zone509exit

        CHECKZONEXY obj510,zone510exit
;-------------------------------------------------------------------
; obj510 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode510obj
        dw modelExplode1
obj510  DWOBJ 0,0,-500,0
zone510exit

        CHECKZONEXY obj511,zone511exit
;-------------------------------------------------------------------
; obj511 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode511obj
        dw modelExplode1
obj511  DWOBJ 0,0,-500,0
zone511exit

        CHECKZONEXY obj512,zone512exit
;-------------------------------------------------------------------
; obj512 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode512obj
        dw modelExplode1
obj512  DWOBJ 0,0,-500,0
zone512exit

        CHECKZONEXY obj513,zone513exit
;-------------------------------------------------------------------
; obj513 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode513obj
        dw modelExplode1
obj513  DWOBJ 0,0,-500,0
zone513exit

        CHECKZONEXY obj514,zone514exit
;-------------------------------------------------------------------
; obj514 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode514obj
        dw modelExplode1
obj514  DWOBJ 0,0,-500,0
zone514exit

        CHECKZONEXY obj515,zone515exit
;-------------------------------------------------------------------
; obj515 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode515obj
        dw modelExplode1
obj515  DWOBJ 0,0,-500,0
zone515exit

        CHECKZONEXY obj516,zone516exit
;-------------------------------------------------------------------
; obj516 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode516obj
        dw modelExplode1
obj516  DWOBJ 0,0,-500,0
zone516exit

        CHECKZONEXY obj517,zone517exit
;-------------------------------------------------------------------
; obj517 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode517obj
        dw modelExplode1
obj517  DWOBJ 0,0,-500,0
zone517exit

        CHECKZONEXY obj518,zone518exit
;-------------------------------------------------------------------
; obj518 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode518obj
        dw modelExplode1
obj518  DWOBJ 0,0,-500,0
zone518exit

        CHECKZONEXY obj519,zone519exit
;-------------------------------------------------------------------
; obj519 - Explode
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
explode519obj
        dw modelExplode1
obj519  DWOBJ 0,0,-500,0
zone519exit
       endif




       if 0 
        CHECKZONEXY obj005,zone005exit
;-------------------------------------------------------------------
; obj005 - Skeleton
;-------------------------------------------------------------------
        call IXDOOBJ_NOSHADER_JR
shambler005obj
        dw skeleton
obj005  DWOBJ -10*64,-27*64,-32 ,0
zone005exit
       endif 




        ret ;/my_objects










;==========================================================================
;==   ()
;==========================================================================
;+0      
   ;0 -  
   ;1 -      
   ;2 -  
;+1+2         3D 

bochkaDIM
       if 0
       ;   2  
        db      2                       ;
        dw      bochka250obj            ;    3D 
        db      2                       ;
        dw      bochka251obj            ;    3D 
        db      2                       ;
        dw      bochka252obj            ;    3D 
        db      2                       ;
        dw      bochka253obj            ;    3D 
       endif 
        db      #FF                     ; 

;==========================================================================
;==  
;==========================================================================
;+0      
   ;0 -  
   ;1 - 
   ;2 - 
   ;3 - 
   ;4 -  1
   ;5 -  2
   ;6 -  3
   ;7 - ...
   ;14-  4
;+1+2         3D 
   
itemsDIM
       if 0
        db      1                       ;
        dw      obj300                  ;    3D 
        db      2                       ;
        dw      obj301                  ;    3D 
        db      3                       ;
        dw      obj302                  ;    3D 
        db      4                       ; 1
        dw      obj303                  ;    3D 
        db      5                       ; 2
        dw      obj304                  ;    3D 
        db      6                       ; 3
        dw      obj305                  ;    3D 
        db      7                       ; 1
        dw      obj306                  ;    3D 
        db      8                       ; 2
        dw      obj307                  ;    3D 
        db      9                       ;
        dw      objExit                 ;    3D   
       if HIMEM         
        db      10                      ;
        dw      obj204                  ;    3D 
        db      10                      ;   
        dw      obj205                  ;    3D 
       endif 
        db      12                      ;  
        dw      obj203                  ;    3D 
        db      11                      ;  
        dw      obj170                  ;    3D 
        
        db      12                      ;  
        dw      obj171                  ;    3D 
        db      13                      ;  
        dw      obj172                  ;    3D 
        db      14                      ; 3
        dw      obj312                  ;    3D 
        
        db      13                      ;  
        dw      obj214                  ;    3D 
        db      13                      ;     
        dw      obj215                  ;    3D         
        
;        db      14                      ; E
;        dw      obj308
;        db      15                      ; W
;        dw      obj309
;        db      16                      ; N
;        dw      obj310
;        db      17                      ; S
;        dw      obj311
       endif
        db      #FF                     ; 

;==========================================================================
;==  
;==========================================================================

;+0+1   X     0..65535
;+2+3   Y     0..65535
;+4+5   X,      0..65535
;+6+7   Y,      0..65535
;+8           

teleportsDIM
       if 0
        dw      41*64, 43*64            ;X,Y
        dw      39*64, 27*64            ;Xnew,Ynew
        db      128                     ;alpha        
        dw      40*64, 27*64            ;X,Y
        dw      41*64, 44*64            ;Xnew,Ynew
        db      64                      ;alpha
       ; 
        dw      34*64, 46*64            ;X,Y
        dw      57*64, 59*64            ;Xnew,Ynew
        db      192                     ;alpha        
        dw      57*64, 60*64            ;X,Y
        dw      35*64, 47*64            ;Xnew,Ynew
        db      32                      ;alpha
       ; 
        dw      20*64, 51*64            ;X,Y
        dw      14*64, 51*64            ;Xnew,Ynew
        db      128                     ;alpha        
        dw      15*64, 51*64            ;X,Y
        dw      20*64, 52*64            ;Xnew,Ynew
        db      64                      ;alpha
       ; 
        dw      20*64, 61*64            ;X,Y
        dw      14*64, 61*64            ;Xnew,Ynew
        db      128                     ;alpha        
        dw      15*64, 61*64            ;X,Y
        dw      20*64, 60*64            ;Xnew,Ynew
        db      192                     ;alpha        
       ;
        dw      8*64, 53*64             ;X,Y
        dw      9*64, 59*64             ;Xnew,Ynew
        db      0                       ;alpha        
        dw      8*64, 59*64             ;X,Y
        dw      9*64, 53*64             ;Xnew,Ynew
        db      0                       ;alpha
       endif
        db      #FF                     ;  
        
;==========================================================================
;==  
;==========================================================================

;+0      
   ;0 -  
   ;1 - 
   ;2 - -
   ;3 - 
   ;4 -   
   ;5 -   
;+1+2   X    0..65535
;+3+4   Y    0..65535
;+5+6   Z    0..65535
;+7+8   dX
;+9+10  dY
;+11+12 dZ
;+13+14    
;[+15+16       3D  =  + 2]

shotsDIM
        db      0                       ; 
        dw      0,0,-500                ;X,Y,Z
        dw      0,0,0                   ;dX,dY,dZ
        dw      shot400obj;,obj400       ;    3D 
        db      0                       ; 
        dw      0,0,-500                ;X,Y,Z
        dw      0,0,0                   ;dX,dY,dZ
        dw      shot401obj;,obj401       ;    3D  
        db      0                       ; 
        dw      0,0,-500                ;X,Y,Z
        dw      0,0,0                   ;dX,dY,dZ
        dw      shot402obj;,obj402       ;    3D 
        db      0                       ; 
        dw      0,0,-500                ;X,Y,Z
        dw      0,0,0                   ;dX,dY,dZ
        dw      shot403obj;,obj403       ;    3D  
        db      0                       ; 
        dw      0,0,-500                ;X,Y,Z
        dw      0,0,0                   ;dX,dY,dZ
        dw      shot404obj;,obj404       ;    3D     
        db      0                       ; 
        dw      0,0,-500                ;X,Y,Z
        dw      0,0,0                   ;dX,dY,dZ
        dw      shot405obj;,obj405       ;    3D       
        db      0                       ; 
        dw      0,0,-500                ;X,Y,Z
        dw      0,0,0                   ;dX,dY,dZ
        dw      shot406obj;,obj406       ;    3D     
        db      0                       ; 
        dw      0,0,-500                ;X,Y,Z
        dw      0,0,0                   ;dX,dY,dZ
        dw      shot407obj;,obj407       ;    3D   

        db      #FF                     ; 
        
;==========================================================================
;==  
;==========================================================================

;+0      
   ;0 -  
   ;1 - 
   ;2 - 
   ;3 - 
   ;4 - ...
;+1+2   X    0..65535
;+3+4   Y    0..65535
;+5      Z 
;+6     ,    (alpha)
;+7          0..255
;+8+9          ;      3D  =  + 2]
;+10     

unitsDIM
        db      0                   ;1 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      turboSvine601obj    ;    3D 
        db      0                   ; 
        
        db      0                   ;1 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      turboSvine602obj    ;    3D 
        db      0                   ; 
        
        db      0                   ;1 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      turboSvine603obj    ;    3D 
        db      0                   ; 
        
        db      0                   ;1 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      turboSvine604obj    ;    3D 
        db      0                   ; 
        
        db      0                   ;1 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      turboSvine605obj    ;    3D 
        db      0                   ; 
        
        db      0                   ;1 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      turboSvine606obj    ;    3D 
        db      0                   ; 
        
        
        db      0                   ;3 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      vorchun611obj       ;    3D  
        db      0                   ; 
        
        db      0                   ;3 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      vorchun612obj       ;    3D  
        db      0                   ; 

        db      0                   ;3 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      vorchun613obj       ;    3D  
        db      0                   ; 
        

        db      0                   ;2 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      shambler621obj      ;    3D 
        db      0                   ; 
        
        db      0                   ;2 
        DWOB    0,0                 ;X,Y
        db      0,0,0               ;Z,alpha,anim
        dw      shambler622obj      ;    3D 
        db      0                   ; 
        
        
        db      #FF                 ; 
        
;==========================================================================
;==  
;==========================================================================

;+0      
   ;0 -  
   ;1 -   
   ;2 -  
   ;3 - ...
   ;4 -     
   ;5 -     
   ;6 -   
   ;7 -    ()
;+1      
;+2+3      
;[+4+5         3D  =  + 2]

explodeDIM
        db      0,0                     ; ,  
        dw      explode500obj;,obj500    ;    3D  
        db      0,0                     ; ,  
        dw      explode501obj;,obj501    ;    3D 
        db      0,0                     ; ,  
        dw      explode502obj;,obj502    ;    3D 
       if HIMEM
        db      0,0                     ; ,  
        dw      explode503obj;,obj503    ;    3D 
        db      0,0                     ; ,  
        dw      explode504obj;,obj504    ;    3D      
        db      0,0                     ; ,  
        dw      explode505obj;,obj505    ;    3D 
        db      0,0                     ; ,  
        dw      explode506obj;,obj506    ;    3D 
        db      0,0                     ; ,  
        dw      explode507obj;,obj507    ;    3D 
        db      0,0                     ; ,  
        dw      explode508obj;,obj508    ;    3D      
        db      0,0                     ; ,  
        dw      explode509obj;,obj509    ;    3D     

        db      0,0                     ; ,  
        dw      explode510obj;,obj510    ;    3D  
        db      0,0                     ; ,  
        dw      explode511obj;,obj511    ;    3D 
        db      0,0                     ; ,  
        dw      explode512obj;,obj512    ;    3D 
        db      0,0                     ; ,  
        dw      explode513obj;,obj513    ;    3D 
        db      0,0                     ; ,  
        dw      explode514obj;,obj514    ;    3D      
        db      0,0                     ; ,  
        dw      explode515obj;,obj515    ;    3D 
        db      0,0                     ; ,  
        dw      explode516obj;,obj516    ;    3D 
        db      0,0                     ; ,  
        dw      explode517obj;,obj517    ;    3D 
        db      0,0                     ; ,  
        dw      explode518obj;,obj518    ;    3D      
        db      0,0                     ; ,  
        dw      explode519obj;,obj519    ;    3D           
       endif
        db      #FF                     ; 
        
        
        
        
        
        
        
        
        
        
        
        



;      ---------------------------------------
;: A=ugolRotation
shaderRotatRT
ugAlphaRT=$+1
        ld a,0;(ugAlphaRT)
        ex af,af' ;'
        ret
shaderRotatLF
ugAlphaLF=$+1
        ld a,64;(ugAlphaLF)
        ex af,af' ;'
        ret

;    UpDn  -----------------------
;: A=ugol
shaderUpDn
sinUpDn=$+1
        ld a,0;(sinUpDn)
        add a,l
        ld l,a
        ret
ugAlphaUpDn db 0

;:  HL,  
;: bc=-X
;     de=-Y
;     hl=Z
getobjXYZ;minusCam
        ld c,(hl)
        inc hl
        ld b,(hl) ;-X 
         inc hl
        ld e,(hl)
        inc hl
        ld d,(hl) ;-Y 
        inc hl
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a ;Z 
        ret

IXDOOBJ_NOSHADER_JR
        pop hl
        ld a,(hl)
        ld lx,a
        inc hl
        ld a,(hl)
        ld hx,a
        inc hl
;hl=obj
        ld c,(hl)
        inc hl
        ld b,(hl) ;-X   
         inc hl
        ld e,(hl)
        inc hl
        ld d,(hl) ;-Y   
        inc hl
        ld a,(hl) ;Z
        ex af,af' ;'
        inc hl
        inc hl
        ld a,(hl) ;alpha ;(obj+6)
       dup OBJSIZE_skipafteralpha
        inc hl
       edup
       push hl ;(sp)=obj+OBJSIZE
       dup OBJSIZE_skipafteralpha
        dec hl
       edup
        dec hl
        ld h,(hl)
        ex af,af' ;'
        ld l,a ;Z ;(obj+4)
;bc=-X
;de=-Y
;hl=Z
;a'=alpha
        call DOOBJ;jp DOOBJ
zone_setregs
centerXbase=$+1
        ld de,0 ;de= +(    -   )
centerYbase=$+1
        ld bc,0 ;bc= +(    -   )
        ret 

DOOBJ_JR
;bc=-X
;de=-Y
;hl=Z
        ex (sp),hl ;get return addr
        ld a,l
        add a,OBJSIZE
        ld l,a
        jr nc,$+3
        inc h
        ex (sp),hl ;keep return addr
;bc=-X
;de=-Y
;hl=Z
;a'=alpha
        ;ex de,hl
        jp DOOBJ

centerX dw 0
centerY dw 0

;mulDist ;neg                     ;%00000011 %00000001
        ;sla a                   ;%00000110 %00000010
        ; de=de*a (  )
        ;ret

;        
visiblSegmCP
              ;de=X*64 ;hl=Y*64
        ;ld bc,32        ;32   
        ;add hl,bc        
        ld a,l
        and %11000000
        ld l,a
        srl h : rr l : srl h : rr l ;de=Y*64->Y*16
        ex de,hl
        ;add hl,bc
        ld a,l
        and %11000000
        ld l,a        
              ;de=Y*16 ;hl=X*64
        add hl,hl
        add hl,hl
        ld l,h
        ld h,0 ;hl=X*1
        add hl,de       ;Y*16+X        
        ld de,m
        add hl,de       ;m+Y*16+X
        ld a,(hl)
        cp SEGM
        ;ret c
        ;ld a,0;xor a ;      ,   
        ret
        

_=0x8000 ;,   alpha
;    000, 001, 002, 003, 004, 005, 006, 007, 008, 009, 010, 011, 012, 013, 014, 015, 016
;           ^ -   !
tabObj  ;dw m00, p04, p03, p04, p03, p02, p01, p02, p01, t02, t03, t04, t05, m03, m03, m03, m03  ;0x30 - 3D 56
        ;dw m00, p04, p03, p04, p03, p02, p01, p02, p01, p01, p01, p01, p01, p02, p03, p04, p04 ;
        ;dw m00, p04, p03, p04, p03, p02, p01, p02, p01, m00, t02, m00, t03, m00, t04, m00, t05  ;0x50 -        
        dw m00, p04, p03, p04, p03, p04, p03, p02, p01, p02, p01, p02, p01, t02, t03, t04, t05  ;0x50 - 
        ;dw m00, p04, p03, p04, p03, p04, p02, p01, p02, p01, p02, t02, t03, t04, t05, m03, m03  ;0x50 - 
        
tabZ    ;db 000, 000, 008, 016, 024, 032, 040, 048, 056, 064, 072, 080, 088, 096+16, 104+16, 112+16, 120+16                 
        db 000, 000, 016, 032, 048, 064, 080, 096, 112, 128, 144, 160, 176, 192, 208, 224, 240
        ;db 000, 000, 000, 000, 000, 000, 000, 000, 000, 000, 000, 000, 000, 000, 000, 000, 000


       
       if 0
;      
;:    hl,x    -X  
;       de,y*64 -Y    
;       a,index -  (  ),           
setSegm add hl,de       ;X+Y*64
        ld de,m
        add hl,de       ;startMap+X+Y*64
        ld (hl),a
        ret
       endif
       

	;display "---------- my_objects --- end ",/D,$
	;display "---------- my_objects --- size ",/D,$-my_objects
        ;display "---------- RESULT (all my level): ",/D,$-rotmodelbegin
