;--------------------------------------------------------------------
;: 3D engine v1.47++++ - 30.11.2024
;:  Alone Coder '1997-2024
;--------------------------------------------------------------------

        device zxspectrum1024
main=#8000;#6400
progtable=#4000 ;for PRELINES
;makers=#4100

xbase=#80;#c0 ;#80   scrbuf=#d000+: scf:rr h:sra h???
ybase=#80;#c0 ;#80   ( CY -   >128) ; #80+(scrhgt/2)       -   

        include "colours.asm"

        include "my_settings.asm"

TEX256=0;1
TEXINTERLACE=1&(!ATM)
       if ATM
VIDEOMODE=0xa8;EGA+turbo
       endif

interlacedivisor=1+INTERLACE ;2 for interlace
midy=realmidy/interlacedivisor

scrhgt=realscrhgt/interlacedivisor ;152  /  112 176 192
fakescrhgt=scrhgt-scrtopyshift-scrbottomyshift;40;32 ;  
	if PRELINES&&(xbase != #80)
scrbuf=#d000+ybase-midy ;#e080+#10
	else
;scrbuf=#e000+ybase-(scrhgt/2) ;#e080+#10
scrbuf=#6000+ybase-midy ;#e080+#10
	endif

scrbrim=(32-scrwid)/2
scrbufmid=(scrbuf&#ff00)+#1000-(scrbrim*256)
       if ATM
scrbase=0x0000+4+(40*topy)
scrbottom=0x0000+4+(40*200) ;fake line for clipping (4 copies: +0, +0x2000, +0x4000, +0x6000)
       else
scrtop=0x4000+((topy&0xc0)<<5)+((topy&0x38)<<2)+((topy&0x07)<<8)
       endif

drawpolytopy=ybase-midy
drawpolybottomy=drawpolytopy+scrhgt

       if HIMEM;ATM
endfree=0x10000
endall=endfree
       else
endfree=((BACKGROUND-1)&0xffff)+1;#e000
endall=endfree+0x2000
       endif

	if PRELINES
;  xbase=#c0!!!   
endfree=endfree-#100 ;-   X  (max 8 pix)
;linemaxhgt=31 ;63 segments
;jumptable=#a000
linemaxhgt=7 ;15 segments
jumptable=endfree-(256*(linemaxhgt*2+1)) ;=#d000
jumptable_center=jumptable+(linemaxhgt*256)
;   #9409..#a93e
;todo    ,  jp    ( ?)
endfree=jumptable
	endif

_tables=endfree
        ;display "end of _tables=",_tables

makers=0x5b00

pglevel=4
pgtmap=6
pgengine=0
       if ATM
pgwasmusic=3 ; ATM   pgmusic
pgmusic=8
pgwaspanorama0=1 ; pggfx ; ATM   pgpanorama0, pgpanorama1
pgpanorama0=9
pgpanorama1=10
pgwassfx=7
pgsfx=11
pgdata=12 ;    gfx
       else
pgmusic=3
pgsfx=7;1
pggfx=1
pgpanorama=pgmusic
       endif

        include "macros.asm"

	org 0x6000
begin   
        jr begin2
        db "QUAKE v.0.06 beta for ZX Spectrum 128k by Dragons' Lord 2023"
begin2
        ei
        halt
        xor a
	out (0xfe),a            ;Border  
	ld hl,#5800;+64
	ld de,#5801;+64
	ld bc,767;-256-64
	ld (hl),0               ;  
	ldir

       if ATM
        xor a
	ld (0x5d10),a ;for TR-DOS
	ld (iy+1),0xcc ;"128K basic off"
;TODO  vTRDOS
        if ATM
	;push af
	ld bc,0xff77 ;  
        ld a,0xab;0xa8;VIDEOMODE;0xab ;bit2..0 = videomode
        call outdos
	;pop af
        endif
        ld a,0x7f-pgdata
        call my_loadfiles
       endif

        ei ;    ,          
        halt
        call initmouse
        ;di

	 ld bc,0xfbdf
	 in a,(c)
	 ld (oldmousex),a
	 ld bc,0xffdf
	 in a,(c)
	 ld (oldmousey),a

        if ATM
        ld bc,0xbd77 ;   
        ;ld bc,0xfd77 ; 
        ld a,0xab;VIDEOMODE;0xab ;bit2..0 = videomode
        call outdos
        ;ld a,0x7f-1
        ;call setpg0000
        ld hl,blackpal+31
        call setpal
        endif

        di

       if MUSIC
       if ATM
        ld a,pgwasmusic
        call setpg;_music
       else
        call setpg_music
       endif
        call 0xc000
        if ATM
;copy music pg from pgmusic to pg8
        ld bc,0xbff7
        ld a,0x7f-pgmusic
        out (c),a
        ld hl,0xc000
        ld de,0x8000
        ld bc,0x4000
        ldir
        endif
       endif

       if ATM
        ld bc,0xfff7
        ld a,0x7f-pgwassfx
        out (c),a
        ld bc,0xbff7
        ld a,0x7f-pgsfx
        out (c),a
        ld hl,0xc000
        ld de,0x8000
        ld bc,0x4000
        ldir
       endif

       if ATM && BACKGROUND
       if 1
        ld bc,0x3ff7
        ld a,0x7f-pgwaspanorama0
        out (c),a
        ld bc,0xbff7
        ld a,0x7f-pgpanorama0
        out (c),a
        ld bc,0xfff7
        ld a,0x7f-pgpanorama1
        out (c),a
        ld hl,0x0000
        ld de,0x8000
        call DEC40
        ;ld bc,0x3ff7
        ;ld a,0x80+3 ;48K switchable
        ;out (c),a ;  ;    
       else
;copy pgpanorama0
        ld a,pgwaspanorama0|0x10
        ;call setpg
        ld bc,0x7ffd
        out (c),a
        ld bc,0xbff7
        ld a,0x7f-pgpanorama0
        out (c),a
        ld hl,0xc000
        ld de,0x8000
        ld bc,0x4000
        ldir
;copy pgpanorama1
        ld a,pgwaspanorama1|0x10
        ;call setpg
        ld bc,0x7ffd
        out (c),a
        ld bc,0xbff7
        ld a,0x7f-pgpanorama1
        out (c),a
        ld hl,0xc000
        ld de,0x8000
        ld bc,0x4000
        ldir
       endif
       endif

        if ATM
        ld bc,0xbff7
        ld a,0x7f-2 ; 
        out (c),a
        endif

       ld a,IMVEC/256
       ld i,a
	im 2
	ld a,(timer)
	ld (oldtimer),a

	ld sp,STACK

	ld hl,wasmakers
	ld de,makers
	ld bc,szmakers
	ldir

        ei
        halt

        if ATM
        ld a,0x20 ;ATM3 palette
        out (0xbf),a
         ld bc,0xbd77 ;   
         ld a,VIDEOMODE;0xab ;bit2..0 = videomode
         out (c),a ;      
        ;call outdos

        ;ld hl,blackpal+31
        ;call setpal
        endif
        ;jr $

       if HIMEM
        call setpg_level
       endif
        call my_initworld
       if HIMEM
        call setpg_engine
       endif
	jp makers; -> my_showpanel -> waithalt

initmouse
      ;,     - min 2500   Evo (  280  )
      LD B,75
prosirtime
      LD DE,(0)        ;20 
      DJNZ prosirtime  ;13 
  ld a, 0x90
  out (0x7F), a
  out (0x5F), a
  ld bc, 0x0FFDF
  in h, (c)
  ld b, 0x0FB
  in l, (c)
  dec b
  in a, (c)
  cp l
  ret nz ;jr nz, @detected
  cp h
  ret nz ;jr z, @comeon
        ;ld a,0xc9 ;"ret"
        ;ld (readmouse_patch),a
        ld hl,0x18+(256*readmousejr) ;"jr"
        ld (readmouse_patch),hl
        ret

       if ATM
blackpal
        ds 32,0xff
       endif

       if ATM
        include "megaLZunpack.asm" ;DEC40
       endif

       if ATM
        include "my_loader.asm"

loadfile
;hl=filename
;a=pg
        ;ld bc,0x7ffd ;FIX
        ;out (c),a ;FIX
        push hl
        ld bc,0xfff7
        call outdos
        pop hl
         push af
       if 1;DISK
         ;ld hl,tmodule
	ld de,#5cdd
	ld bc,9
	ldir
         push hl
	ld c,#a ;find
	call #3d13
	ld a,c
	ld c,#8 ;load descr
	call #3d13
	xor a
	ld (23801),a
         ;ld hl,tmodule+6
         ;inc (hl)
	ld hl,0xc000
	ld de,(#5ce8) ;length
	ld a,3
	ld c,#e ;load file
	call #3d13
         pop hl
         pop af
         dec a ;next page
         ret
       else
        ld ix,0xc000
        ld de,17
        xor a
        scf
        call 1366
        ld ix,0xc000
        ld de,(0xc000+11);0x4000
        scf
        sbc a,a
        jp 1366
       endif
       endif

wasmakers
	disp makers
;makers
        include "makers.asm"
	ent
szmakers=$-wasmakers
;=====================================

	ds main-$
       if ATM
        ds 0x300
objlistend=$;_tables
       else
objlistend=0x5fe0;0x5fc0
       endif
       if HIMEM
objliststart=objlistend-(64*12);0x300
       else
objliststart=objlistend-(64*12);(32*12);0x180
       endif

        align 256
tcos
tcos_himem
	INCBIN "cos" ; 0 ( ROTATE_OBJECT, my_objects, my_logic)
tsindiv2
	INCBIN "sindiv2" ; 0 ( ROTATE_MATRIX, drawbackground)
TBLOG2;=0x5c00
	ds 512 ;log2(X)
TB2X;=0x5b00
	ds 255;256 ;(2^X)-1 (0<X<1)

       if ATM
        ds ($|0xff)-$
       else
        align 256
       endif
IMVEC=$|0xff
IMER=(($/0x100)+1)*0x101
       if ATM
	ds 2,0xff&IMER
       else
	ds 0x101,0xff&IMER
       endif
timer
	db 0;dw 0
framesdrawn
	db 0
;drawsp
        ds 32;64
STACK
        ds 32;16;10
IMERSP

       if !HIMEM
;DOOBJ=engine_doobj
       else
DOOBJ
;bc=-X ( =Z')
;de=-Y ( =X')
;hl=Z ( =Y')
;a'=alpha angle
       ;push af
       push bc
        call setpg_engine
       pop bc
       ;pop af
        call engine_doobj
setpg_level
        ld a,pglevel
        jr setpg
setpg_tmap
        ld a,pgtmap
        jr setpg
setpg_engine
        ld a,pgengine
        jr setpg
setpg_music
        ld a,pgmusic
        jr setpg
setpg_sfx
        ld a,pgsfx
        jr setpg
       if !ATM        
setpg_gfx
        ld a,pggfx
        jr setpg        
       endif 
       endif

       if HIMEM
setpg
       if ATM
        ld (curpg),a
        xor 0x7f
        ld bc,0xfff7
        out (c),a
        ret
curscrnum
        db 0x10
       else
curscrnum=$+1
        or 0x10;0x18
        ld (curpg),a
        ld bc,0x7ffd
        out (c),a
        ret
       endif
       endif

	;if IMVEC!=#3bff
        display "skip before ON_INT=",IMER-$
        ds IMER-$
ON_INT
;     de
	 ex de,hl
	ex (sp),hl ;hl="de" ,   
	ld (IMERjp),hl
	pop hl ; hl="de"
	 ex de,hl
	ld (IMERwassp),sp
	ld sp,IMERSP
	push af,bc,hl
        ld hl,timer
        inc (hl)
       if SHOWFPSON
timersec=$+1
	ld a,1
	dec a
	call z,showfps ;out: a=50
	ld (timersec),a
       endif

      if HIMEM
curpg=$+1      
        ld a,0x10;(curpg)
        push af
      endif
       push de
       push ix
       push iy
       ex af,af' ;'
       push af

readmouse_patch=$ ;/jr
        if ATM
        ld bc,0x3ff7
        ld a,0x83 ;basic48
        out (c),a
        ld bc,0xff77
        ld a,VIDEOMODE;0xab
        out (c),a
        endif

       ld bc,0xffdf ;mouse y
       in h,(c)
       ld b,0xfb ;mouse x
       in l,(c)
       ld (curmousexy),hl
       dec b ;ld b,0xfa
       in a,(c)
       ld (curmousekeys),a
        if ATM        
        ld bc,0xbd77
        ld a,VIDEOMODE;0xab
        call outdos
curpg0000=$+1
        ld a,0x7f;(curpg0000)
        ld bc,0x3ff7
        out (c),a
        endif
readmousejr=$-(readmouse_patch+2)

       if ATM
        ld a,(curscrnum)
        ld bc,0x7ffd
        out (c),a
        ld (newscrnum),a
       endif
        call my_int

       pop af
       ex af,af' ;'
       pop iy
       pop ix
       pop de
      if HIMEM   
        pop af
        call setpg
      endif
      
	pop hl,bc,af
IMERwassp=$+1
	ld sp,0
	ei
IMERjp=$+1
	jp 0

	include "drawfaces.asm" ;contains ALIGN 256

showfps
sysFPScount=$+1
        ld a,0
      if !ATM
       if SHOWFPSON
        or a
        ret     z
;out: a=50
	ld a,(framesdrawn)
	push de
	ld de,#50e0;#401d
	ld bc,10-256
	inc b
	sub c
	jr nc,$-2
	add a,c
	ld c,a
	ld a,b
	call showdig
	ld a,c
	call showdig
	pop de
	xor a
	ld (framesdrawn),a
	ld a,50
	ret
showdig
	add a,'0'
	push de
	add a,a
	ld h,15
	ld l,a
	add hl,hl
	add hl,hl
	ld b,8
showdig0
	ld a,(hl)
	ld (de),a
	inc l
	inc d
	djnz showdig0
	pop de
	inc e
	;ret
       endif
      endif
      ret

mainloop
     ;ld a,1
     ;out (0xfe),a
       if ATM
        call setpgsscr
       endif
       if HIMEM
        call setpg_engine
       endif
        call drawframe_prepare ;3794
     ;ld a,2
     ;out (0xfe),a
       if HIMEM
        call setpg_level
       endif
        call my_objects       ;29258
     ;ld a,3
     ;out (0xfe),a
       if ATM
        ld a,(curscrnum)
newscrnum=$+1
        cp 0x10
        jr nz,$-2 ;vsync
       endif
        call copyscreencls    ;28041 (  )
     ;ld a,4
     ;out (0xfe),a
                ;ld a,(sysPanorama)
sysPanorama=$+1
                ld a,1;0
                or a;cp      0
                call nz,drawbackground
     ;ld a,5
     ;out (0xfe),a
       if HIMEM
        call setpg_engine
       endif
       if FLOORON
       ;if HIMEM
       ; call setpg_engine
       ;endif
        call DOFLOOR;drawframe_floor   ;26000  -    
       endif
	call sortobjpop
     ;ld a,6
     ;out (0xfe),a
       if HIMEM
        call setpg_level
       endif
        call my_sprites
     ;ld a,7
     ;out (0xfe),a
        
       if HIMEM
        call setpg_engine
       endif
        call drawframe_show   ;437959[587764] (217940[342707] ( 92237  )  DRAWPOLY, ..   220019[245057])
     ;ld a,0
     ;out (0xfe),a
       if SHOWFPSON
	ld hl,framesdrawn
	inc (hl)
       endif
waithalt
       if HIMEM
        call setpg_level
       endif

	ld a,(timer)
oldtimer=$+1
	ld e,0
	sub e
         cp RENDERSPEEDLIMIT
	jp c,waithalt;mainloop
        add a,e
	ld (oldtimer),a
   if LOGICSPEED ;   LOGICSPEED
       sub e ;a=  
logicframesremained=$+1
       add a,0 ;0..LOGICSPEED-1
timeraction0
        ld (logicframesremained),a
        sub LOGICSPEED
        jr c,timeraction0q
	push af
	call my_logic
	pop af
	jr timeraction0  ;4200  25 fps  (10000  50 fps )   
timeraction0q
   else ; 25 fps  ( 50  RENDERSPEEDLIMIT==1) -  17 fps 
      if RENDERSPEEDLIMIT > 1
       res 0,a
       res 0,e
      endif
       sub e
      if RENDERSPEEDLIMIT > 1
       srl a
      endif
	ld b,a
timeraction0
	push bc
	call my_logic
	pop bc
	djnz timeraction0  ;4200  25 fps  (10000  50 fps )   
   endif
;quit
	jp mainloop

       if ATM
setpgsscr_hidden
        ld a,(curpgscr)
        xor 2
        jr setpgsscr_go
setpgsscr
        ld a,(curpgscr)
setpgsscr_go
        ld (curpg0000),a
        ld bc,0x3ff7
        out (c),a
        xor 4
        ld b,0x7f;bc,0x7ff7
        out (c),a
        ret

clearscreen
        call setpgsscr
        ld hl,0x0000+((scrhgt*(1+INTERLACE)+topy)*40)
        call clearscreen_page
        ld hl,0x4000+((scrhgt*(1+INTERLACE)+topy)*40)
        call clearscreen_page
        ld hl,0x2000+((scrhgt*(1+INTERLACE)+topy)*40)
        call clearscreen_page
        ld hl,0x6000+((scrhgt*(1+INTERLACE)+topy)*40)
        ;call clearscreen_page
clearscreen_page
       ld de,(0xfffe)
       push de
       ld (clearscreensp),sp
       ld sp,hl;0x8000
        ld de,0
        ld b,scrhgt*(1+INTERLACE)
clearscreen0
        dup 20;64
        push de
        edup
        djnz clearscreen0
clearscreensp=$+1
        ld sp,0
       pop hl ;ld hl,0x101*((scrbase+(40*200))/256)
       ld (0xfffe),hl ;   ty
        ret
curpgscr
        db 0x7f-3;1
       endif        

       if ATM

primgega
;b=hgt,c=wid (/2)
;de=yx
;hl=gfx
        push hl
        call xytoscrde_ega
        pop hl
        ex de,hl
;b=hgt,c=wid (/2)
;de=gfx
;hl=scr
primgega0
        push bc
        ld hx,b
        push hl
        ld bc,40
primgegacolumn0
        ld a,(de)
        inc de
        ld (hl),a
        add hl,bc
        dec hx
        jr nz,primgegacolumn0
        pop hl
        bit 6,h
        set 6,h
        jr z,primgegacolumn0q ;  
        ld a,h
        xor 0x60
        ld h,a
        and 0x60
        jr nz,primgegacolumn0q
        inc hl
primgegacolumn0q
        pop bc
        dec c
        jr nz,primgega0
        ret

showsprite_twoscr
        push de
        push hl
        call setpgsscr_hidden
        call showsprite
        pop hl
        pop de
        call setpgsscr
        jp showsprite

xytoscrde_ega
        ld l,d ;y
        ld h,0
        ld a,e ;x
        ld d,h
        ld e,l ;y
        add hl,hl
        add hl,hl
        add hl,de
        add hl,hl
        add hl,hl
        add hl,hl ;y*40+scrbase
         if scrbase&0xff
         add a,scrbase&0xff
         endif
;a=x/4
        add a,l
        ld e,a
        adc a,h
        sub e
        ld d,a ;de=scr
        ret

showsprite_pga
;a=pg
        call setpg
showsprite
;hl=gfx
;d=y (midy=center)
;e=x8 (16=center)
        push hl
        ld a,d ;y
        add a,topy+(realmidy-ybase)
        ld d,a
        call xytoscrde_ega
        ld b,d
        ld c,e
        pop hl

        ld (showspritesp),sp
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        ld sp,hl ;protected from INT
        ld h,b
        ld l,c
        ld bc,40
;   : 0) , 1) ld, 2) and:or
;  pop de,   
;    8  (4  )   0,1,2,3 (,  0,1,3,2,       X)
        ;pop de ;e=wid, d=hgt
        ld lx,e ;wid count
        ld hy,d ;hgt
maskspratm_column
        ld (maskspratm_newcolumnhl),hl
        ld ly,hy ;hgt count := hgt
maskspratm_loop
;hy=hgt
;lx=wid count
;ly=hgt count
        pop de ;e=zonetype, d=zonehgt
        ld hx,d ;zonehgt
       ld a,ly ;hgt count
       sub d ;zonehgt
       ld ly,a ;hgt count
        ld a,e
        or a
        jr z,skipspratm
        dec a
        jr nz,maskspratm
ldspratm0
        pop de
        ld (hl),e
        set 6,h
        ld (hl),d
        set 5,h
        pop de
        ld (hl),d;e
        res 6,h
        ld (hl),e;d
        res 5,h
        add hl,bc
        dec hx
        jr nz,ldspratm0
        jr maskspratmq
maskspratm
maskspratm0
        pop de
        ld a,(hl)
        and e
        or d
        ld (hl),a
        set 6,h
        pop de
        ld a,(hl)
        and e
        or d
        ld (hl),a
         res 6,h
        set 5,h
        pop de
        ld a,(hl)
        and e
        or d
        ld (hl),a
        ;res 6,h
         set 6,h
        pop de
        ld a,(hl)
        and e
        or d
        ld (hl),a
         res 6,h
        res 5,h
        add hl,bc
        dec hx
        jr nz,maskspratm0
        jr maskspratmq
skipspratm
        ld a,d ;hgt
skipspratm0
        add hl,bc
        dec a
        jp nz,skipspratm0
maskspratmq
        ld a,ly
        or a
        jr nz,maskspratm_loop
maskspratm_newcolumnhl=$+1
        ld hl,0
        inc hl
        dec lx ;wid count
        jr nz,maskspratm_column
showspritesp=$+1
        ld sp,0
        ret
       endif

       if !ATM
showsprite
;hl=gfx
;d=y (midy=center)
;e=x8 (16=center)
        ld c,(hl)
        inc hl
        ld b,(hl)
        inc hl
       if INTERLACE
       ;srl b
       ld a,d
       sub realmidy
       sra a
       add a,100;scrhgt/2;midy ;FIXME    ???
       ld d,a
       endif
;b=hgt
;c=wid8
        ld a,e
        ld e,d ;y
        add a,scrbuf/256
        ld d,a
showsprite0
        push bc
        push de
        ld a,d
        cp scrbuf/256
        jr c,showsprite0skip
       if INTERLACE
       ld a,(copyscreen_phase)
       rra
       jr nc,showsprite0skipfirst
       endif
showsprite1
        ld a,(de)
        or (hl)
        inc hl
        xor (hl)
        ld (de),a
        inc hl
       if INTERLACE
       dec b
       jr z,showsprite0skip
showsprite0skipfirst
       inc hl
       inc hl
       endif
        inc e
        djnz showsprite1
showsprite0skip
        pop de
        pop bc
        inc d
        ret z
        dec c
        jr nz,showsprite0
        ret
       endif
        ;display "---------- showsprite        ",/D,showsprite
        ;display "---------- scrbuf               ",/D,scrbuf

       if ATM
outdos
        ld hl,10835
        push hl
        jp 0x3d2f
       endif

DRAWTMAP
;a=brtmap+texture#
                ex af,af' ;'
sysTexture=$+1
                ld a,TMAP ;     
       if TMAP
                or a
                 ld a,br3r;br1a
                 jp z,DRAWTMAP_FAIL
                ex af,af' ;'
       if TEX256
        add a,0xff&(tmaptexture/256 - (brtmap*1))
        ld hx,a;tmaptexture/256
        call setpg_tmap
       else
        if TEXINTERLACE
        ld l,a
        call setpg_tmap
        ld a,l
       if TMAPMUL3
        add a,a
        add a,l
        add a,0xff&(tmaptexture/256 - (brtmap*3))
       else
        add a,tmaptexture/256 - brtmap
       endif
        ld hx,a;tmaptexture/256
       if INTERLACE
        ld a,(copyscreen_phase)
        rra
        jr nc,$+4
        inc hx
       else
        inc a
        xor hx
        ld (tmapline_hxxor),a
       endif
        else ;~TEXINTERLACE
        add a,a
        add a,0xff&(tmaptexture/256 - (brtmap*2))
        ld hx,a;tmaptexture/256
        call setpg_tmap
       endif
       endif
        jp drawtmap_inpage
       endif

        include "drawbackground.asm" ;lowmem

        include "rotvertex.asm"
        include "3dmodel.asm"
	include "rotobj.asm"

       if EDGES || DRAWVERTICES
	include "drawedges.asm" ;not used in lunohod
       endif

	include "rotmatrix.asm" ;lowmem (?)

	include "input.asm" ;lowmem (    pglevel)

       if ATM
copyscreencls=clearscreen
       else
	include "display.asm" ;lowmem
       endif

	include "sortobj.asm" ;lowmem
	include "drawframe.asm" ;  himem

        if ATM
setmypal
        halt
        ld hl,pal+31
setpal
        ld c,0xff
        ld a,7
        dup 8
        OUT (0xF6),A
        ld d,(hl)
        dec hl
        ld b,(hl) ;DDp palette low bits
        OUT (c),d;(0xFF),A
        dec hl
        dec a
        edup
        ld a,7
        dup 7
        OUT (0xFE),A
        ld d,(hl)
        dec hl
        ld b,(hl) ;DDp palette low bits
        OUT (c),d;(0xFF),A
        dec hl
        dec a
        edup
        OUT (0xFE),A ;0
        ld d,(hl)
        dec hl
        ld b,(hl) ;DDp palette low bits
        OUT (c),d;(0xFF),A
        ret
        include "../_tmp/pal.ast"
        endif

       if HIMEM
       display "engine end=",$
       endif
       
myInt
        include "my_int.asm" ;lowmem
myIntEnd        
        include "my_interface.asm" ;lowmem

        include "my_savestate.asm" ;lowmem

       if HIMEM
       display "lowmemend=",$," <= 0xc000"
       endif

polySTART=$
        include "my_poly.asm"
polyEND=$
vertexSTART=$
        include "my_vertex.asm"
vertexEND=$

       if GLUECORNERS
curobjxy
        dw gluedvertices
curobjxyincy
        dw gluedvertices
curobjxyincx
        dw gluedvertices
curobjxyincyincx
        dw gluedvertices
       endif

       if GLUECORNERS
	BEGIN256 (768*GLUECORNERS)
gluedvertices
        display "gluedvertices=",gluedvertices
       dup GLUECORNERS
        ds 256 ;z (1=not yet counted)
        ds 256 ;y' projected
        ds 256 ;x' projected
       edup
         ;ds 768
	END256
       endif

	include "projectvertex.asm"
	include "visibility.asm"
       if FLOORON
	include "floor.asm"
       endif

       if !HIMEM
objectsBEGIN=$
objectsSTART=$
        include "my_objects.asm"
objectsEND=$
logicSTART=$
	include "my_logic.asm"
logicEND=$
;        align 256
;mapQuake
;        include "my_map.asm"
;mapEND=$
;objectsUL=$
       if TMAP
	include "drawtmap.asm"
       endif
	include "my_textures.asm"
       endif

beginfree

       if BACKGROUND & !HIMEM
        org endfree
        ;ds endfree-$ ;  
        incbin "../_tmp/panorama.bin";0x2000
       endif

       if HIMEM
       ;if MUSIC
        page 3
        org 0xc000
hicode3_begin
        include "my_music.asm"
       display "after music=",/D,65536-$-8192 ;    
       if BACKGROUND & !ATM
        ds BACKGROUND-$
        incbin "../_tmp/panorama.bin";0x2000
       endif
hicode3_end
        ;display "hicode3_begin=",hicode3_begin
        ;display "hicode3_end=",hicode3_end
       ;endif

        page 4
        org 0xc000
hicode_begin
objectsBEGIN=$
objectsSTART=$
        include "my_objects.asm"
objectsEND=$
logicSTART=$
	include "my_logic.asm"
logicEND=$
;        align 256
;mapQuake
;        include "my_map.asm"
;mapEND=$
;objectsUL=$
hicode_end

        page 6
        org 0xc000
hicode6_begin
       if TMAP
	include "drawtmap.asm"
	include "my_textures.asm"
       endif
hicode6_end
       endif

       if HIMEM
        include "my_pages.asm"
       endif

;       if ATM
;objlistend=_tables
;       else
;objlistend=0x5fe0;0x5fc0
;       endif

endtables=_tables ;for sortobj
        display "_tables=",_tables
        ;display "-- ",/D,$," .. ",/D,_tables,"(_tables) free in .bin ",/D,_tables-$

        display "active end=",beginfree
        ;display "--- >>> USER LEVEL -------------------------"
        ;display "--- my_int           ",/D,myInt,"..",/D,myIntEnd," size ",/D,myIntEnd-myInt
        ;display "--- my_gfx         ",/D,hicode1_begin,"..",/D,hicode1_end," size ",/D,hicode1_end-hicode1_begin+1792
         ;display "--- my_gfx         ",/D,hicode1_begin,"..",/D,hicode1_my," free ",/D,63744-hicode1_my
        ;display "--- my_sfx          ",/D,hicode7_begin,"..",/D,hicode7_end," size ",/D,hicode7_end-hicode7_begin
        display "--- my_poly        ",/D,polySTART,"..",/D,polyEND," (pgengine) size ",/D,polyEND-polySTART
        display "--- my_vertex    ",/D,vertexSTART,"..",/D,vertexEND," (pgengine) size ",/D,vertexEND-vertexSTART
        display "--- my_objects   ",/D,objectsSTART,"..",/D,objectsEND," (pglevel) size ",/D,objectsEND-objectsSTART
        display "--- my_logic   ",/D,logicSTART,"..",/D,logicEND," (pglevel) size ",/D,logicEND-logicSTART
        ;display "--- my_map        ",/D,mapQuake,"..",/D,mapEND," (pglevel) size ",/D,mapEND-mapQuake
       if ATM
        display "-- ",/D,beginfree," .. ",/D,_tables,"=_tables (pgengine) free for engine ",/D,_tables-beginfree ;   -        
       else
        display "-- ",/D,beginfree," .. ",/D,_tables,"=_tables (pgengine) free for engine ",/D,_tables-beginfree ;  object list    0x5fc0
       endif
        ;display "-- ",/D,beginfree," .. ",/D,_tables,"(_tables) free for object list ",/D,_tables-beginfree
       if HIMEM
        display "-- ",/D,hicode_end," .. ",/D,0x10000," (pglevel) free for objects+map ",/D,0x10000-hicode_end;mapEND ;         ;display "--------------------------------------------  size  ",/D,objectsUL-startUL
       endif

        page 0
        ;display "endall=",endall
	savebin "../_tmp/code.c",begin,endall-begin
       if HIMEM
       ;if MUSIC
        page 3
	savebin "../_tmp/hicode3.c",hicode3_begin,hicode3_end-hicode3_begin
       ;endif
        page 4
	savebin "../_tmp/hicode4.c",hicode_begin,hicode_end-hicode_begin
        page 6
	savebin "../_tmp/hicode6.c",hicode6_begin,hicode6_end-hicode6_begin
       endif

	LABELSLIST "../../us/user.l";,1
