// Extension for exporting maps from "Tiled Map Editor" by 2023 (c) Dragons' Lord
// The map is saved in a text format that sjasmplus Cross-Assembler can read.

var acmeMapFormat = {
    name: "defb 000",
    extension: "asm",

    write: function(map, fileName) {
	
		// Create file
        var file = new TextFile(fileName, TextFile.WriteOnly);

		// Write each tile layer in map
        for (var i = 0; i < map.layerCount; ++i) {
            var layer = map.layerAt(i);
            if (layer.isTileLayer) {
				
                // Write each row in current layer
				for (y = 0; y < layer.height; ++y) {
                                var row = "\tdefb ";
                    
					// Write each column in current layer
					for (x = 0; x < (layer.width-1); ++x) {
						var cell = layer.cellAt(x, y);
						// Build a 16 bit hex value for each tile
						var val = cell.tileId+1;
						// let each value be in the format "$xxxx"
                                                row += ("000" + val.toString(10)).slice(-3) + ",";
                                        }
                                        x = (layer.width-1);
						var cell2 = layer.cellAt(x, y);
						// Build a 16 bit hex value for each tile
						var val2 = cell2.tileId+1;
						// let each value be in the format "$xxxx"
                                                row += ("000" + val2.toString(10)).slice(-3);
					file.writeLine(row);
                                }
				file.writeLine("");
            }
        }
        file.commit();
    },
}

tiled.registerMapFormat("defb 000", acmeMapFormat)